"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.classValidator = void 0;
var tslib_1 = require("tslib");
var debug_1 = tslib_1.__importDefault(require("debug"));
var class_transformer_validator_1 = require("class-transformer-validator");
var logger = debug_1.default("@lambda-middleware/class-transformer");
exports.classValidator = function (options) { return function (handler) { return function (event, context) { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
    var body, transformer, validator, transformedBody, error_1;
    var _a, _b;
    return tslib_1.__generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                logger("Checking input " + JSON.stringify(event.body));
                _c.label = 1;
            case 1:
                _c.trys.push([1, 3, , 4]);
                body = (_a = event.body) !== null && _a !== void 0 ? _a : "{}";
                transformer = options.transformer;
                validator = (_b = options.validator) !== null && _b !== void 0 ? _b : {
                    whitelist: true,
                };
                return [4 /*yield*/, class_transformer_validator_1.transformAndValidate(options.bodyType, body === "" ? "{}" : body, { transformer: transformer, validator: validator })];
            case 2:
                transformedBody = (_c.sent());
                logger("Input is valid");
                return [2 /*return*/, handler(tslib_1.__assign(tslib_1.__assign({}, event), { body: transformedBody }), context)];
            case 3:
                error_1 = _c.sent();
                logger("Input is invalid");
                error_1.statusCode = 400;
                throw error_1;
            case 4: return [2 /*return*/];
        }
    });
}); }; }; };
//# sourceMappingURL=classValidator.js.map